'' Copyright (c) 2009, FreeBASIC Extended Library Development Group
''
'' All rights reserved.
''
'' Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
''
''  * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
''  * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
''  * Neither the name of the FreeBASIC Extended Library Development Group nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
''
'' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
'' "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
'' LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
'' A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
'' CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
'' EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
'' PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
'' PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
'' LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
'' NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
'' SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# include once "ext/error.bi"

namespace ext

	'' :::::
	function GetErrorText (byval err_number as integer) as string

		var errtext = ""

		select case as const err_number
			case 0 : errtext = "No error"
			case 1 : errtext = "Illegal function call"
			case 2 : errtext = "File not found signal"
			case 3 : errtext = "File I/O error"
			case 4 : errtext = "Out of memory"
			case 5 : errtext = "Illegal resume"
			case 6 : errtext = "Out of bounds array access"
			case 7 : errtext = "Null Pointer Access"
			case 8 : errtext = "No privileges"
			case 9 : errtext = "Interrupted signal"
			case 10 : errtext = "Illegal instruction signal"
			case 11 : errtext = "Floating point error signal"
			case 12 : errtext = "Segmentation violation signal"
			case 13 : errtext = "Termination request signal"
			case 14 : errtext = "Abnormal termination signal"
			case 15 : errtext = "Quit request signal"
			case else : errtext = "Unknown error"
		end select

		return errtext

	end function

end namespace ' ext

