''Copyright (c) 2009, FreeBASIC Extended Library Development Group
''
''All rights reserved.
''
''Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
''
''    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
''    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
''    * Neither the name of the FreeBASIC Extended Library Development Group nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.
''
''THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
''"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
''LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
''A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
''CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
''EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
''PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
''PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
''LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
''NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
''SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# include once "ext/graphics/manip.bi"
#include once "crt.bi"

namespace ext.gfx

sub change_color ( byref img as FB.IMAGE ptr, byval from_ as uinteger, byval to_ as uinteger, byval include_alpha as ext.bool = ext.bool.false, byval is_font as ext.bool = ext.bool.false )

	if img = ext.null then exit sub
	if img->bpp < 4 then exit sub 'this procedure only operates on 24 & 32 bit bitmaps

	var pitch_ = img->width
	var height_ = img->height
	var len_data = pitch_ * height_
	var pixelptr = FBEXT_FBGFX_PIXELPTR( uinteger, img )
	dim start_data as uinteger = 0

	if (is_font = ext.bool.true) then
		start_data = pitch_

	end if

	for n as uinteger = start_data to len_data -1

		var cur_color = cuint(0)
		if include_alpha = ext.bool.true then
			cur_color = pixelptr[n]

		else
			cur_color = pixelptr[n] AND &h00FFFFFF

		end if

		if cur_color = from_ then
			if include_alpha = ext.bool.true then
				pixelptr[n] = to_

			else
				pixelptr[n] = (pixelptr[n] AND &hFF000000) OR to_

			end if

		end if

	next n

end sub

Function flipVertical _
        ( _
                Byval img As fb.image Ptr _
        ) As fb.image Ptr

        Dim As fb.image Ptr temp_img
        Dim As Ubyte Ptr    p1
        Dim As Ubyte Ptr    p2

        temp_img = imagecreate( img->width, img->height )

        p1 = cptr( Ubyte Ptr, img ) + sizeof( fb.image ) + ((img->height - 1) * img->pitch)
        p2 = cptr( Ubyte Ptr, temp_img ) + sizeof( fb.image )

        For y As Integer = 0 To img->height - 1
                memcpy( p2, p1, img->pitch )
                p1 -= img->pitch
                p2 += img->pitch
        Next y

        imagedestroy( img )

        Function = temp_img

End Function

end namespace 'ext.gfx
