#include once "ext/options.bi"
using ext

if __FB_ARGC__ < 2 then 'print usage

	print "This is an example program for the FB Extended Library."
	print "It has the following options (they do nothing):"
	print 
	print "-d / --delete file_to_not_delete"
	print "-c / --commit [optional message]"
	print "-e / --erase file_to_not_erase"
	print
	print "You may give the -d / --delete option multiple times on one"
	print "commandline, but all the others can only be used once."
	print
	end 23

end if

var myOpts = new ext.options.Parser

var copt = myOpts->addOption("c","commit",true) 'has optional argument
var dopt = myOpts->addOption("d","delete", true, true, true ) 'has required argument and is repeatable
var eopt = myOpts->addOption("e","erase", true, true) 'has required argument

myOpts->parse(__FB_ARGC__,__FB_ARGV__)

if myOpts->hasError then 
	print myOpts->getError()
	end 42
else
	print "No Errors processing commandline, presenting results..."
end if

if myOpts->isSet( copt ) then 
	print "opt c set: ";
	var x = myOpts->getArg(copt)
	if len(x) > 0 then
		print x
	else
		print "argument not supplied"
	end if
else
	print "opt c not set"
end if

if myOpts->isSet( dopt ) then 
	print "opt d set: ";
	print myOpts->getArg( dopt )
else
	print "opt d not set"
end if

if myOpts->isSet( eopt ) then 
	print "opt e set: ";
	print myOpts->getArg( eopt )
else
	print "opt e not set"
end if

print "Non options:"
print myOpts->getRemainder()

delete myOpts

