''Title: database/driver.bi
''
''About: License
''Copyright (c) 2009, FreeBASIC Extended Library Development Group
''
''Distributed under the FreeBASIC Extended Library Group license. See
''accompanying file LICENSE.txt or copy at
''http://code.google.com/p/fb-extended-lib/wiki/License


''Namespace: ext.database
namespace ext.database

type DatabaseDriverF as DatabaseDriver

type DBOpenFunc as function( byval d as  DatabaseDriverF ptr, byref connect as const string ) as integer
type DBCloseFunc as function( byval d as DatabaseDriverF ptr ) as integer
type DBPrepareFunc as function( byval d as DatabaseDriverF ptr, byref sql as const string ) as integer
type DBStepFunc as function( byval d as DatabaseDriverF ptr ) as integer
type DBColInResult as function( byval d as DatabaseDriverF ptr ) as integer
type DBColName as function( byval d as DatabaseDriverF ptr, byval col as integer ) as string
type DBColVal as function( byval d as DatabaseDriverF ptr, byval col as integer ) as string
type DBCleanup as function( byval d as DatabaseDriverF ptr ) as integer
type DBError as function( byval d as DatabaseDriverF ptr, byval code as integer ) as string
type DBHandle as function( byval d as DatabaseDriverF ptr ) as any ptr
type STMTHandle as function( byval d as DatabaseDriverF ptr ) as any ptr
type DDdestroy as sub( byval d as DatabaseDriverF ptr )

''Type: DatabaseDriver
''A group of function pointers to enable access to a database.
''
''To see how to write a DatabaseDriver see the file src/modules/database/drivers/sqlite3.bas.
type DatabaseDriver
	as DBOpenFunc opendb
	as DBCloseFunc closedb
	as DBPrepareFunc prepdb
	as DBStepFunc stepfunc
	as DBColInResult numcols
	as DBColName colname
	as DBColVal colval
	as DBCleanup cleanup
	as DBError geterr
	as DBHandle gethandle
	as STMTHandle sthandle
	as DDdestroy destroy
	as any ptr driverdata
end type

end namespace
