''Title: variant.bi
''
''About: License
''Copyright (c) 2009, FreeBASIC Extended Library Development Group
''
''Distributed under the FreeBASIC Extended Library Group license. See
''accompanying file LICENSE.txt or copy at
''http://code.google.com/p/fb-extended-lib/wiki/License

#ifndef FBEXT_VARIANT_BI__
#define FBEXT_VARIANT_BI__ -1

#include once "ext/detail/common.bi"
#include once "ext/misc.bi"

namespace ext

enum VariantType explicit
	bool_
	byte_
	ubyte_
	short_
	ushort_
	integer_
	uinteger_
	longint_
	ulongint_
	single_
	double_
	string_
end enum

type Variant
	public:
	declare function toString( ) as string
	# macro fbext_VariantGet_Declare(T_)
	:
	declare operator cast ( ) as fbext_TypeName(T_)
	:
	# endmacro
	
	# macro fbext_VariantLet_Declare(T_)
	:
	declare operator let( byref x as fbext_TypeName(T_) )
	:
	# endmacro
	
	declare function contains() as VariantType
	
	fbext_InstanciateMulti( fbext_VariantLet, fbext_NumericTypes() )
	
	fbext_VariantLet_Declare(string)
	
	
	
	declare destructor()
	
	private:
	id as VariantType
	union
		bo as bool
		b as byte
		ub as ubyte
		s as short
		us as ushort
		i as integer
		u as uinteger
		li as longint
		uli as ulongint
		si as single
		d as double
		st as zstring ptr
	end union
end type

end namespace
