'' Title: ext/preprocessor/tuple/replace.bi
''  This file is part of the <ext/Preprocessor> library API, and can be
''  directly included by user programs.
''
'' About: License
''  Copyright (c) 2009, FreeBASIC Extended Library Development Group
''  Copyright (c) 2002, Paul Mensonides
''
''  Distributed under the Boost Software License, Version 1.0. See
''  accompanying file LICENSE_1_0.txt or copy at
''  http://www.boost.org/LICENSE_1_0.txt)
''
''  Distributed under the FreeBASIC Extended Library Group license. See
''  accompanying file LICENSE.txt or copy at
''  http://code.google.com/p/fb-extended-lib/wiki/License

# pragma once
# ifndef FBEXT_INCLUDED_PP_TUPLE_REPLACE_BI__
# define FBEXT_INCLUDED_PP_TUPLE_REPLACE_BI__ -1

# include once "ext/preprocessor/tuple/remparens.bi"

# define FBEXT_PP_TUPLE_REPLACE(size, index, tuple, value) fbextPP_TupleReplace(size, index, tuple, value)

'' Macro: fbextPP_TupleReplace
''  expands to a copy of *tuple* of *size* with the element value at *index*
''  replaced with *value*.
''
''  For example, if *size* is `3`, *index* is `1`, *tuple* is `(a,b,c)` and
''  *value* is `x`, then this macro expands to `(a,x,c)`.
''
'' Parameters:
''  size - is the count of elements in the tuple.
''  index - is the index of the element to replace.
''  tuple - is the tuple which contains the element to replace.
''  value - is the new value to element.
# define fbextPP_TupleReplace(size, index, tuple, value) _
    _fbextPP_TupleReplace__##size##__##index(value, fbextPP_TupleRemParens(size, tuple))

# define _fbextPP_TupleReplace__1__0(value, __0) (value)

# define _fbextPP_TupleReplace__2__0(value, __0, __1) (value, __1)
# define _fbextPP_TupleReplace__2__1(value, __0, __1) (__0, value)

# define _fbextPP_TupleReplace__3__0(value, __0, __1, __2) (value, __1, __2)
# define _fbextPP_TupleReplace__3__1(value, __0, __1, __2) (__0, value, __2)
# define _fbextPP_TupleReplace__3__2(value, __0, __1, __2) (__0, __1, value)

# define _fbextPP_TupleReplace__4__0(value, __0, __1, __2, __3) (value, __1, __2, __3)
# define _fbextPP_TupleReplace__4__1(value, __0, __1, __2, __3) (__0, value, __2, __3)
# define _fbextPP_TupleReplace__4__2(value, __0, __1, __2, __3) (__0, __1, value, __3)
# define _fbextPP_TupleReplace__4__3(value, __0, __1, __2, __3) (__0, __1, __2, value)

# define _fbextPP_TupleReplace__5__0(value, __0, __1, __2, __3, __4) (value, __1, __2, __3, __4)
# define _fbextPP_TupleReplace__5__1(value, __0, __1, __2, __3, __4) (__0, value, __2, __3, __4)
# define _fbextPP_TupleReplace__5__2(value, __0, __1, __2, __3, __4) (__0, __1, value, __3, __4)
# define _fbextPP_TupleReplace__5__3(value, __0, __1, __2, __3, __4) (__0, __1, __2, value, __4)
# define _fbextPP_TupleReplace__5__4(value, __0, __1, __2, __3, __4) (__0, __1, __2, __3, value)

# define _fbextPP_TupleReplace__6__0(value, __0, __1, __2, __3, __4, __5) (value, __1, __2, __3, __4, __5)
# define _fbextPP_TupleReplace__6__1(value, __0, __1, __2, __3, __4, __5) (__0, value, __2, __3, __4, __5)
# define _fbextPP_TupleReplace__6__2(value, __0, __1, __2, __3, __4, __5) (__0, __1, value, __3, __4, __5)
# define _fbextPP_TupleReplace__6__3(value, __0, __1, __2, __3, __4, __5) (__0, __1, __2, value, __4, __5)
# define _fbextPP_TupleReplace__6__4(value, __0, __1, __2, __3, __4, __5) (__0, __1, __2, __3, value, __5)
# define _fbextPP_TupleReplace__6__5(value, __0, __1, __2, __3, __4, __5) (__0, __1, __2, __3, __4, value)

# define _fbextPP_TupleReplace__7__0(value, __0, __1, __2, __3, __4, __5, __6) (value, __1, __2, __3, __4, __5, __6)
# define _fbextPP_TupleReplace__7__1(value, __0, __1, __2, __3, __4, __5, __6) (__0, value, __2, __3, __4, __5, __6)
# define _fbextPP_TupleReplace__7__2(value, __0, __1, __2, __3, __4, __5, __6) (__0, __1, value, __3, __4, __5, __6)
# define _fbextPP_TupleReplace__7__3(value, __0, __1, __2, __3, __4, __5, __6) (__0, __1, __2, value, __4, __5, __6)
# define _fbextPP_TupleReplace__7__4(value, __0, __1, __2, __3, __4, __5, __6) (__0, __1, __2, __3, value, __5, __6)
# define _fbextPP_TupleReplace__7__5(value, __0, __1, __2, __3, __4, __5, __6) (__0, __1, __2, __3, __4, value, __6)
# define _fbextPP_TupleReplace__7__6(value, __0, __1, __2, __3, __4, __5, __6) (__0, __1, __2, __3, __4, __5, value)

# define _fbextPP_TupleReplace__8__0(value, __0, __1, __2, __3, __4, __5, __6, __7) (value, __1, __2, __3, __4, __5, __6, __7)
# define _fbextPP_TupleReplace__8__1(value, __0, __1, __2, __3, __4, __5, __6, __7) (__0, value, __2, __3, __4, __5, __6, __7)
# define _fbextPP_TupleReplace__8__2(value, __0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, value, __3, __4, __5, __6, __7)
# define _fbextPP_TupleReplace__8__3(value, __0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __2, value, __4, __5, __6, __7)
# define _fbextPP_TupleReplace__8__4(value, __0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __2, __3, value, __5, __6, __7)
# define _fbextPP_TupleReplace__8__5(value, __0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __2, __3, __4, value, __6, __7)
# define _fbextPP_TupleReplace__8__6(value, __0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __2, __3, __4, __5, value, __7)
# define _fbextPP_TupleReplace__8__7(value, __0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __2, __3, __4, __5, __6, value)

# define _fbextPP_TupleReplace__9__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8) (value, __1, __2, __3, __4, __5, __6, __7, __8)
# define _fbextPP_TupleReplace__9__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, value, __2, __3, __4, __5, __6, __7, __8)
# define _fbextPP_TupleReplace__9__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, value, __3, __4, __5, __6, __7, __8)
# define _fbextPP_TupleReplace__9__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, value, __4, __5, __6, __7, __8)
# define _fbextPP_TupleReplace__9__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __3, value, __5, __6, __7, __8)
# define _fbextPP_TupleReplace__9__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __3, __4, value, __6, __7, __8)
# define _fbextPP_TupleReplace__9__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __3, __4, __5, value, __7, __8)
# define _fbextPP_TupleReplace__9__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __3, __4, __5, __6, value, __8)
# define _fbextPP_TupleReplace__9__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __3, __4, __5, __6, __7, value)

# define _fbextPP_TupleReplace__10__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9)
# define _fbextPP_TupleReplace__10__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9)
# define _fbextPP_TupleReplace__10__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9)
# define _fbextPP_TupleReplace__10__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9)
# define _fbextPP_TupleReplace__10__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9)
# define _fbextPP_TupleReplace__10__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9)
# define _fbextPP_TupleReplace__10__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9)
# define _fbextPP_TupleReplace__10__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9)
# define _fbextPP_TupleReplace__10__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9)
# define _fbextPP_TupleReplace__10__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value)

# define _fbextPP_TupleReplace__11__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10)
# define _fbextPP_TupleReplace__11__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10)
# define _fbextPP_TupleReplace__11__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10)
# define _fbextPP_TupleReplace__11__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10)
# define _fbextPP_TupleReplace__11__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10)
# define _fbextPP_TupleReplace__11__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10)
# define _fbextPP_TupleReplace__11__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10)
# define _fbextPP_TupleReplace__11__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10)
# define _fbextPP_TupleReplace__11__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10)
# define _fbextPP_TupleReplace__11__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10)
# define _fbextPP_TupleReplace__11__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value)

# define _fbextPP_TupleReplace__12__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11)
# define _fbextPP_TupleReplace__12__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11)
# define _fbextPP_TupleReplace__12__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11)
# define _fbextPP_TupleReplace__12__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11)
# define _fbextPP_TupleReplace__12__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11)
# define _fbextPP_TupleReplace__12__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11)
# define _fbextPP_TupleReplace__12__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11)
# define _fbextPP_TupleReplace__12__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11)
# define _fbextPP_TupleReplace__12__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11)
# define _fbextPP_TupleReplace__12__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11)
# define _fbextPP_TupleReplace__12__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11)
# define _fbextPP_TupleReplace__12__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value)

# define _fbextPP_TupleReplace__13__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12)
# define _fbextPP_TupleReplace__13__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12)
# define _fbextPP_TupleReplace__13__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12)
# define _fbextPP_TupleReplace__13__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12)
# define _fbextPP_TupleReplace__13__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12)
# define _fbextPP_TupleReplace__13__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12)
# define _fbextPP_TupleReplace__13__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12)
# define _fbextPP_TupleReplace__13__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12)
# define _fbextPP_TupleReplace__13__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12)
# define _fbextPP_TupleReplace__13__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12)
# define _fbextPP_TupleReplace__13__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12)
# define _fbextPP_TupleReplace__13__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12)
# define _fbextPP_TupleReplace__13__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value)

# define _fbextPP_TupleReplace__14__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13)
# define _fbextPP_TupleReplace__14__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13)
# define _fbextPP_TupleReplace__14__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13)
# define _fbextPP_TupleReplace__14__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13)
# define _fbextPP_TupleReplace__14__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13)
# define _fbextPP_TupleReplace__14__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13)
# define _fbextPP_TupleReplace__14__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13)
# define _fbextPP_TupleReplace__14__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13)
# define _fbextPP_TupleReplace__14__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13)
# define _fbextPP_TupleReplace__14__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13)
# define _fbextPP_TupleReplace__14__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13)
# define _fbextPP_TupleReplace__14__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13)
# define _fbextPP_TupleReplace__14__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13)
# define _fbextPP_TupleReplace__14__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value)

# define _fbextPP_TupleReplace__15__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14)
# define _fbextPP_TupleReplace__15__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14)
# define _fbextPP_TupleReplace__15__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14)
# define _fbextPP_TupleReplace__15__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14)
# define _fbextPP_TupleReplace__15__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value)

# define _fbextPP_TupleReplace__16__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15)
# define _fbextPP_TupleReplace__16__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15)
# define _fbextPP_TupleReplace__16__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15)
# define _fbextPP_TupleReplace__16__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15)
# define _fbextPP_TupleReplace__16__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value)

# define _fbextPP_TupleReplace__17__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16)
# define _fbextPP_TupleReplace__17__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16)
# define _fbextPP_TupleReplace__17__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16)
# define _fbextPP_TupleReplace__17__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16)
# define _fbextPP_TupleReplace__17__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value)

# define _fbextPP_TupleReplace__18__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17)
# define _fbextPP_TupleReplace__18__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17)
# define _fbextPP_TupleReplace__18__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17)
# define _fbextPP_TupleReplace__18__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17)
# define _fbextPP_TupleReplace__18__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value)

# define _fbextPP_TupleReplace__19__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18)
# define _fbextPP_TupleReplace__19__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18)
# define _fbextPP_TupleReplace__19__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18)
# define _fbextPP_TupleReplace__19__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18)
# define _fbextPP_TupleReplace__19__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value)

# define _fbextPP_TupleReplace__20__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19)
# define _fbextPP_TupleReplace__20__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19)
# define _fbextPP_TupleReplace__20__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19)
# define _fbextPP_TupleReplace__20__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19)
# define _fbextPP_TupleReplace__20__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value)

# define _fbextPP_TupleReplace__21__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19, __20)
# define _fbextPP_TupleReplace__21__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19, __20)
# define _fbextPP_TupleReplace__21__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19, __20)
# define _fbextPP_TupleReplace__21__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value, __20)
# define _fbextPP_TupleReplace__21__20(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, value)

# define _fbextPP_TupleReplace__22__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19, __20, __21)
# define _fbextPP_TupleReplace__22__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19, __20, __21)
# define _fbextPP_TupleReplace__22__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value, __20, __21)
# define _fbextPP_TupleReplace__22__20(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, value, __21)
# define _fbextPP_TupleReplace__22__21(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, value)

# define _fbextPP_TupleReplace__23__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19, __20, __21, __22)
# define _fbextPP_TupleReplace__23__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value, __20, __21, __22)
# define _fbextPP_TupleReplace__23__20(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, value, __21, __22)
# define _fbextPP_TupleReplace__23__21(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, value, __22)
# define _fbextPP_TupleReplace__23__22(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, value)

# define _fbextPP_TupleReplace__24__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value, __20, __21, __22, __23)
# define _fbextPP_TupleReplace__24__20(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, value, __21, __22, __23)
# define _fbextPP_TupleReplace__24__21(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, value, __22, __23)
# define _fbextPP_TupleReplace__24__22(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, value, __23)
# define _fbextPP_TupleReplace__24__23(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, value)

# define _fbextPP_TupleReplace__25__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value, __20, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__20(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, value, __21, __22, __23, __24)
# define _fbextPP_TupleReplace__25__21(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, value, __22, __23, __24)
# define _fbextPP_TupleReplace__25__22(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, value, __23, __24)
# define _fbextPP_TupleReplace__25__23(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, value, __24)
# define _fbextPP_TupleReplace__25__24(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, value)

# define _fbextPP_TupleReplace__26__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value, __20, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__20(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, value, __21, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__21(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, value, __22, __23, __24, __25)
# define _fbextPP_TupleReplace__26__22(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, value, __23, __24, __25)
# define _fbextPP_TupleReplace__26__23(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, value, __24, __25)
# define _fbextPP_TupleReplace__26__24(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, value, __25)
# define _fbextPP_TupleReplace__26__25(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, value)

# define _fbextPP_TupleReplace__27__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value, __20, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__20(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, value, __21, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__21(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, value, __22, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__22(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, value, __23, __24, __25, __26)
# define _fbextPP_TupleReplace__27__23(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, value, __24, __25, __26)
# define _fbextPP_TupleReplace__27__24(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, value, __25, __26)
# define _fbextPP_TupleReplace__27__25(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, value, __26)
# define _fbextPP_TupleReplace__27__26(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, value)

# define _fbextPP_TupleReplace__28__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value, __20, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__20(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, value, __21, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__21(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, value, __22, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__22(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, value, __23, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__23(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, value, __24, __25, __26, __27)
# define _fbextPP_TupleReplace__28__24(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, value, __25, __26, __27)
# define _fbextPP_TupleReplace__28__25(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, value, __26, __27)
# define _fbextPP_TupleReplace__28__26(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, value, __27)
# define _fbextPP_TupleReplace__28__27(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, value)

# define _fbextPP_TupleReplace__29__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__20(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, value, __21, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__21(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, value, __22, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__22(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, value, __23, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__23(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, value, __24, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__24(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, value, __25, __26, __27, __28)
# define _fbextPP_TupleReplace__29__25(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, value, __26, __27, __28)
# define _fbextPP_TupleReplace__29__26(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, value, __27, __28)
# define _fbextPP_TupleReplace__29__27(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, value, __28)
# define _fbextPP_TupleReplace__29__28(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, value)

# define _fbextPP_TupleReplace__30__0(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (value, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__1(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, value, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__2(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, value, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__3(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, value, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__4(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, value, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__5(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, value, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__6(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, value, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__7(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, value, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__8(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, value, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__9(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, value, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__10(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, value, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__11(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, value, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__12(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, value, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__13(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, value, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__14(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, value, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__15(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, value, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__16(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, value, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__17(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, value, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__18(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, value, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__19(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, value, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__20(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, value, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__21(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, value, __22, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__22(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, value, __23, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__23(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, value, __24, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__24(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, value, __25, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__25(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, value, __26, __27, __28, __29)
# define _fbextPP_TupleReplace__30__26(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, value, __27, __28, __29)
# define _fbextPP_TupleReplace__30__27(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, value, __28, __29)
# define _fbextPP_TupleReplace__30__28(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, value, __29)
# define _fbextPP_TupleReplace__30__29(value, __0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, value)

# endif ' include guard
