'' Title: ext/preprocessor/tuple/remove.bi
''  This file is part of the <ext/Preprocessor> library API, and can be
''  directly included by user programs.
''
'' About: License
''  Copyright (c) 2009, FreeBASIC Extended Library Development Group
''  Copyright (c) 2002, Paul Mensonides
''
''  Distributed under the Boost Software License, Version 1.0. See
''  accompanying file LICENSE_1_0.txt or copy at
''  http://www.boost.org/LICENSE_1_0.txt)
''
''  Distributed under the FreeBASIC Extended Library Group license. See
''  accompanying file LICENSE.txt or copy at
''  http://code.google.com/p/fb-extended-lib/wiki/License

# pragma once
# ifndef FBEXT_INCLUDED_PP_TUPLE_REMOVE_BI__
# define FBEXT_INCLUDED_PP_TUPLE_REMOVE_BI__ -1

# define FBEXT_PP_TUPLE_REMOVE(size, index, tuple) fbextPP_TupleRemove(size, index, tuple)

'' Macro: fbextPP_TupleRemove
''  removes the element at position *index* stored in the tuple *tuple* of
''  size *size*.
''
''  For example, if *size* is `3`, *index* is `1`, and *tuple* is `(a,b,c)`,
''  then this macro expands to `(a,c)`.
''
'' Parameters:
''  size - is the count of elements in the tuple.
''  index - is the position of the element to remove.
''  tuple - is the tuple which stores the element to remove.
# define fbextPP_TupleRemove(size, index, tuple) _
         fbextPP_TupleRemove__##size##__##index tuple

# define fbextPP_TupleRemove__1__0(__0) ()

# define fbextPP_TupleRemove__2__0(__0, __1) (__1)
# define fbextPP_TupleRemove__2__1(__0, __1) (__0)

# define fbextPP_TupleRemove__3__0(__0, __1, __2) (__1, __2)
# define fbextPP_TupleRemove__3__1(__0, __1, __2) (__0, __2)
# define fbextPP_TupleRemove__3__2(__0, __1, __2) (__0, __1)

# define fbextPP_TupleRemove__4__0(__0, __1, __2, __3) (__1, __2, __3)
# define fbextPP_TupleRemove__4__1(__0, __1, __2, __3) (__0, __2, __3)
# define fbextPP_TupleRemove__4__2(__0, __1, __2, __3) (__0, __1, __3)
# define fbextPP_TupleRemove__4__3(__0, __1, __2, __3) (__0, __1, __2)

# define fbextPP_TupleRemove__5__0(__0, __1, __2, __3, __4) (__1, __2, __3, __4)
# define fbextPP_TupleRemove__5__1(__0, __1, __2, __3, __4) (__0, __2, __3, __4)
# define fbextPP_TupleRemove__5__2(__0, __1, __2, __3, __4) (__0, __1, __3, __4)
# define fbextPP_TupleRemove__5__3(__0, __1, __2, __3, __4) (__0, __1, __2, __4)
# define fbextPP_TupleRemove__5__4(__0, __1, __2, __3, __4) (__0, __1, __2, __3)

# define fbextPP_TupleRemove__6__0(__0, __1, __2, __3, __4, __5) (__1, __2, __3, __4, __5)
# define fbextPP_TupleRemove__6__1(__0, __1, __2, __3, __4, __5) (__0, __2, __3, __4, __5)
# define fbextPP_TupleRemove__6__2(__0, __1, __2, __3, __4, __5) (__0, __1, __3, __4, __5)
# define fbextPP_TupleRemove__6__3(__0, __1, __2, __3, __4, __5) (__0, __1, __2, __4, __5)
# define fbextPP_TupleRemove__6__4(__0, __1, __2, __3, __4, __5) (__0, __1, __2, __3, __5)
# define fbextPP_TupleRemove__6__5(__0, __1, __2, __3, __4, __5) (__0, __1, __2, __3, __4)

# define fbextPP_TupleRemove__7__0(__0, __1, __2, __3, __4, __5, __6) (__1, __2, __3, __4, __5, __6)
# define fbextPP_TupleRemove__7__1(__0, __1, __2, __3, __4, __5, __6) (__0, __2, __3, __4, __5, __6)
# define fbextPP_TupleRemove__7__2(__0, __1, __2, __3, __4, __5, __6) (__0, __1, __3, __4, __5, __6)
# define fbextPP_TupleRemove__7__3(__0, __1, __2, __3, __4, __5, __6) (__0, __1, __2, __4, __5, __6)
# define fbextPP_TupleRemove__7__4(__0, __1, __2, __3, __4, __5, __6) (__0, __1, __2, __3, __5, __6)
# define fbextPP_TupleRemove__7__5(__0, __1, __2, __3, __4, __5, __6) (__0, __1, __2, __3, __4, __6)
# define fbextPP_TupleRemove__7__6(__0, __1, __2, __3, __4, __5, __6) (__0, __1, __2, __3, __4, __5)

# define fbextPP_TupleRemove__8__0(__0, __1, __2, __3, __4, __5, __6, __7) (__1, __2, __3, __4, __5, __6, __7)
# define fbextPP_TupleRemove__8__1(__0, __1, __2, __3, __4, __5, __6, __7) (__0, __2, __3, __4, __5, __6, __7)
# define fbextPP_TupleRemove__8__2(__0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __3, __4, __5, __6, __7)
# define fbextPP_TupleRemove__8__3(__0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __2, __4, __5, __6, __7)
# define fbextPP_TupleRemove__8__4(__0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __2, __3, __5, __6, __7)
# define fbextPP_TupleRemove__8__5(__0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __2, __3, __4, __6, __7)
# define fbextPP_TupleRemove__8__6(__0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __2, __3, __4, __5, __7)
# define fbextPP_TupleRemove__8__7(__0, __1, __2, __3, __4, __5, __6, __7) (__0, __1, __2, __3, __4, __5, __6)

# define fbextPP_TupleRemove__9__0(__0, __1, __2, __3, __4, __5, __6, __7, __8) (__1, __2, __3, __4, __5, __6, __7, __8)
# define fbextPP_TupleRemove__9__1(__0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __2, __3, __4, __5, __6, __7, __8)
# define fbextPP_TupleRemove__9__2(__0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __3, __4, __5, __6, __7, __8)
# define fbextPP_TupleRemove__9__3(__0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __4, __5, __6, __7, __8)
# define fbextPP_TupleRemove__9__4(__0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __3, __5, __6, __7, __8)
# define fbextPP_TupleRemove__9__5(__0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __3, __4, __6, __7, __8)
# define fbextPP_TupleRemove__9__6(__0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __3, __4, __5, __7, __8)
# define fbextPP_TupleRemove__9__7(__0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __3, __4, __5, __6, __8)
# define fbextPP_TupleRemove__9__8(__0, __1, __2, __3, __4, __5, __6, __7, __8) (__0, __1, __2, __3, __4, __5, __6, __7)

# define fbextPP_TupleRemove__10__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__1, __2, __3, __4, __5, __6, __7, __8, __9)
# define fbextPP_TupleRemove__10__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __2, __3, __4, __5, __6, __7, __8, __9)
# define fbextPP_TupleRemove__10__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __3, __4, __5, __6, __7, __8, __9)
# define fbextPP_TupleRemove__10__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __4, __5, __6, __7, __8, __9)
# define fbextPP_TupleRemove__10__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __5, __6, __7, __8, __9)
# define fbextPP_TupleRemove__10__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __4, __6, __7, __8, __9)
# define fbextPP_TupleRemove__10__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __4, __5, __7, __8, __9)
# define fbextPP_TupleRemove__10__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __4, __5, __6, __8, __9)
# define fbextPP_TupleRemove__10__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __4, __5, __6, __7, __9)
# define fbextPP_TupleRemove__10__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9) (__0, __1, __2, __3, __4, __5, __6, __7, __8)

# define fbextPP_TupleRemove__11__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10)
# define fbextPP_TupleRemove__11__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10)
# define fbextPP_TupleRemove__11__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10)
# define fbextPP_TupleRemove__11__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10)
# define fbextPP_TupleRemove__11__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10)
# define fbextPP_TupleRemove__11__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10)
# define fbextPP_TupleRemove__11__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10)
# define fbextPP_TupleRemove__11__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10)
# define fbextPP_TupleRemove__11__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10)
# define fbextPP_TupleRemove__11__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10)
# define fbextPP_TupleRemove__11__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9)

# define fbextPP_TupleRemove__12__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11)
# define fbextPP_TupleRemove__12__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11)
# define fbextPP_TupleRemove__12__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11)
# define fbextPP_TupleRemove__12__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11)
# define fbextPP_TupleRemove__12__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11)
# define fbextPP_TupleRemove__12__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11)
# define fbextPP_TupleRemove__12__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11)
# define fbextPP_TupleRemove__12__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11)
# define fbextPP_TupleRemove__12__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11)
# define fbextPP_TupleRemove__12__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11)
# define fbextPP_TupleRemove__12__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11)
# define fbextPP_TupleRemove__12__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10)

# define fbextPP_TupleRemove__13__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12)
# define fbextPP_TupleRemove__13__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12)
# define fbextPP_TupleRemove__13__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12)
# define fbextPP_TupleRemove__13__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12)
# define fbextPP_TupleRemove__13__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12)
# define fbextPP_TupleRemove__13__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12)
# define fbextPP_TupleRemove__13__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12)
# define fbextPP_TupleRemove__13__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12)
# define fbextPP_TupleRemove__13__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12)
# define fbextPP_TupleRemove__13__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12)
# define fbextPP_TupleRemove__13__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12)
# define fbextPP_TupleRemove__13__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12)
# define fbextPP_TupleRemove__13__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11)

# define fbextPP_TupleRemove__14__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13)
# define fbextPP_TupleRemove__14__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13)
# define fbextPP_TupleRemove__14__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13)
# define fbextPP_TupleRemove__14__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13)
# define fbextPP_TupleRemove__14__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13)
# define fbextPP_TupleRemove__14__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13)
# define fbextPP_TupleRemove__14__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13)
# define fbextPP_TupleRemove__14__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13)
# define fbextPP_TupleRemove__14__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13)
# define fbextPP_TupleRemove__14__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13)
# define fbextPP_TupleRemove__14__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13)
# define fbextPP_TupleRemove__14__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13)
# define fbextPP_TupleRemove__14__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13)
# define fbextPP_TupleRemove__14__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12)

# define fbextPP_TupleRemove__15__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14)
# define fbextPP_TupleRemove__15__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14)
# define fbextPP_TupleRemove__15__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14)
# define fbextPP_TupleRemove__15__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14)
# define fbextPP_TupleRemove__15__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13)

# define fbextPP_TupleRemove__16__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15)
# define fbextPP_TupleRemove__16__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15)
# define fbextPP_TupleRemove__16__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15)
# define fbextPP_TupleRemove__16__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15)
# define fbextPP_TupleRemove__16__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14)

# define fbextPP_TupleRemove__17__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16)
# define fbextPP_TupleRemove__17__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16)
# define fbextPP_TupleRemove__17__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16)
# define fbextPP_TupleRemove__17__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16)
# define fbextPP_TupleRemove__17__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15)

# define fbextPP_TupleRemove__18__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17)
# define fbextPP_TupleRemove__18__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17)
# define fbextPP_TupleRemove__18__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17)
# define fbextPP_TupleRemove__18__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17)
# define fbextPP_TupleRemove__18__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16)

# define fbextPP_TupleRemove__19__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18)
# define fbextPP_TupleRemove__19__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18)
# define fbextPP_TupleRemove__19__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18)
# define fbextPP_TupleRemove__19__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18)
# define fbextPP_TupleRemove__19__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17)

# define fbextPP_TupleRemove__20__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19)
# define fbextPP_TupleRemove__20__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19)
# define fbextPP_TupleRemove__20__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19)
# define fbextPP_TupleRemove__20__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19)
# define fbextPP_TupleRemove__20__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18)

# define fbextPP_TupleRemove__21__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20)
# define fbextPP_TupleRemove__21__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20)
# define fbextPP_TupleRemove__21__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20)
# define fbextPP_TupleRemove__21__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20)
# define fbextPP_TupleRemove__21__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19)

# define fbextPP_TupleRemove__22__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20, __21)
# define fbextPP_TupleRemove__22__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20, __21)
# define fbextPP_TupleRemove__22__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20, __21)
# define fbextPP_TupleRemove__22__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __21)
# define fbextPP_TupleRemove__22__21(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20)

# define fbextPP_TupleRemove__23__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20, __21, __22)
# define fbextPP_TupleRemove__23__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20, __21, __22)
# define fbextPP_TupleRemove__23__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __21, __22)
# define fbextPP_TupleRemove__23__21(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __22)
# define fbextPP_TupleRemove__23__22(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21)

# define fbextPP_TupleRemove__24__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20, __21, __22, __23)
# define fbextPP_TupleRemove__24__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __21, __22, __23)
# define fbextPP_TupleRemove__24__21(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __22, __23)
# define fbextPP_TupleRemove__24__22(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __23)
# define fbextPP_TupleRemove__24__23(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22)

# define fbextPP_TupleRemove__25__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __21, __22, __23, __24)
# define fbextPP_TupleRemove__25__21(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __22, __23, __24)
# define fbextPP_TupleRemove__25__22(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __23, __24)
# define fbextPP_TupleRemove__25__23(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __24)
# define fbextPP_TupleRemove__25__24(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23)

# define fbextPP_TupleRemove__26__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __21, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__21(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __22, __23, __24, __25)
# define fbextPP_TupleRemove__26__22(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __23, __24, __25)
# define fbextPP_TupleRemove__26__23(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __24, __25)
# define fbextPP_TupleRemove__26__24(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __25)
# define fbextPP_TupleRemove__26__25(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24)

# define fbextPP_TupleRemove__27__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __21, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__21(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __22, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__22(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __23, __24, __25, __26)
# define fbextPP_TupleRemove__27__23(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __24, __25, __26)
# define fbextPP_TupleRemove__27__24(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __25, __26)
# define fbextPP_TupleRemove__27__25(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __26)
# define fbextPP_TupleRemove__27__26(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25)

# define fbextPP_TupleRemove__28__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __21, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__21(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __22, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__22(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __23, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__23(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __24, __25, __26, __27)
# define fbextPP_TupleRemove__28__24(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __25, __26, __27)
# define fbextPP_TupleRemove__28__25(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __26, __27)
# define fbextPP_TupleRemove__28__26(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __27)
# define fbextPP_TupleRemove__28__27(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26)

# define fbextPP_TupleRemove__29__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __21, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__21(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __22, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__22(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __23, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__23(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __24, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__24(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __25, __26, __27, __28)
# define fbextPP_TupleRemove__29__25(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __26, __27, __28)
# define fbextPP_TupleRemove__29__26(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __27, __28)
# define fbextPP_TupleRemove__29__27(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __28)
# define fbextPP_TupleRemove__29__28(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27)

# define fbextPP_TupleRemove__30__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __21, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__21(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __22, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__22(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __23, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__23(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __24, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__24(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __25, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__25(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __26, __27, __28, __29)
# define fbextPP_TupleRemove__30__26(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __27, __28, __29)
# define fbextPP_TupleRemove__30__27(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __28, __29)
# define fbextPP_TupleRemove__30__28(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __29)
# define fbextPP_TupleRemove__30__29(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28)

# define fbextPP_TupleRemove__31__0(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__1(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__2(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__3(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__4(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__5(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__6(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__7(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__8(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__9(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__10(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__11(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__12(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__13(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__14(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__15(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__16(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__17(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__18(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__19(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__20(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__21(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __22, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__22(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __23, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__23(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __24, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__24(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __25, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__25(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __26, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__26(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __27, __28, __29, __30)
# define fbextPP_TupleRemove__31__27(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __28, __29, __30)
# define fbextPP_TupleRemove__31__28(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __29, __30)
# define fbextPP_TupleRemove__31__29(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __30)
# define fbextPP_TupleRemove__31__30(__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29, __30) (__0, __1, __2, __3, __4, __5, __6, __7, __8, __9, __10, __11, __12, __13, __14, __15, __16, __17, __18, __19, __20, __21, __22, __23, __24, __25, __26, __27, __28, __29)

# endif ' include guard
